3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
40 # The function takes at most 2 arguments. The first argument is the
41 # URL that navigates to the submodule origin repo. When relative, this URL
42 # is relative to the superproject origin URL repo. The second up_path
43 # argument, if specified, is the relative path that navigates
44 # from the submodule working tree to the superproject working tree.
46 # The output of the function is the origin URL of the submodule.
48 # The output will either be an absolute URL or filesystem path (if the
49 # superproject origin URL is an absolute URL or filesystem path,
50 # respectively) or a relative file system path (if the superproject
51 # origin URL is a relative file system path).
53 # When the output is a relative file system path, the path is either
54 # relative to the submodule working tree, if up_path is specified, or to
55 # the superproject working tree otherwise.
56 resolve_relative_url ()
58 remote=$(get_default_remote)
59 remoteurl=$(git config "remote.$remote.url") ||
60 remoteurl=$(pwd) # the repository is its own authoritative upstream
62 remoteurl=${remoteurl%/}
75 remoteurl="./$remoteurl"
86 remoteurl="${remoteurl%/*}"
89 remoteurl="${remoteurl%:*}"
93 if test -z "$is_relative" || test "." = "$remoteurl"
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
113 # Resolve a path to be relative to another path. This is intended for
114 # converting submodule paths when git-submodule is run in a subdirectory
115 # and only handles paths where the directory separator is '/'.
117 # The output is the first argument as a path relative to the second argument,
118 # which defaults to $wt_prefix if it is omitted.
121 local target curdir result
123 curdir=${2-$wt_prefix}
127 while test -n "$curdir"
131 target=${target#"$curdir"/}
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
141 curdir="${curdir%/*}"
145 echo "$result$target"
149 # Get submodule info for registered submodules
150 # $@ = path to limit submodule list
154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
156 git ls-files -z --error-unmatch --stage -- "$@" ||
157 echo "unmatched pathspec exists"
161 my ($null_sha1) = ("0" x 40);
166 if (/^unmatched pathspec/) {
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
175 if (!$unmerged{$path}++) {
176 push @out, "$mode $null_sha1 U\t$path\n";
183 print "#unmatched\n";
192 if test "$1" = "#unmatched"
199 # Print a submodule configuration setting
201 # $1 = submodule name
205 # Checks in the usual git-config places first (for overrides),
206 # otherwise it falls back on .gitmodules. This allows you to
207 # distribute project-wide defaults in .gitmodules, while still
208 # customizing individual repositories if necessary. If the option is
209 # not in .gitmodules either, print a default value.
211 get_submodule_config () {
215 value=$(git config submodule."$name"."$option")
218 value=$(git config -f .gitmodules submodule."$name"."$option")
220 printf '%s' "${value:-$default}"
225 # Map submodule path to submodule name
231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
238 printf '%s\n' "$name"
244 # $1 = submodule path
245 # $2 = submodule name
247 # $4 = reference repository to reuse (empty for independent)
248 # $5 = depth argument for shallow clones (empty for deep)
250 # Prior to calling, cmd_update checks that a possibly existing
251 # path is not a git repository.
252 # Likewise, cmd_add checks that path does not exist at all,
253 # since it is the location of a new submodule.
263 if test -n "$GIT_QUIET"
270 base_name=$(dirname "$name")
272 gitdir=$(git rev-parse --git-dir)
273 gitdir_base="$gitdir/modules/$base_name"
274 gitdir="$gitdir/modules/$name"
279 rm -f "$gitdir/index"
281 mkdir -p "$gitdir_base"
284 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
285 --separate-git-dir "$gitdir" "$url" "$sm_path"
287 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
290 # We already are at the root of the work tree but cd_to_toplevel will
291 # resolve any symlinks that might be present in $PWD
292 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
293 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
294 # Remove all common leading directories after a sanity check
295 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
296 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
298 while test "${a%%/*}" = "${b%%/*}"
303 # Now chop off the trailing '/'s that were added in the beginning
307 # Turn each leading "*/" component into "../"
308 rel=$(printf '%s\n' "$b" | sed -e 's|[^/][^/]*|..|g')
309 printf '%s\n' "gitdir: $rel/$a" >"$sm_path/.git"
311 rel=$(printf '%s\n' "$a" | sed -e 's|[^/][^/]*|..|g')
312 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
317 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
321 # Add a new submodule to the working tree, .gitmodules and the index
325 # optional branch is stored in global branch variable
329 # parse $args after "submodule ... add".
335 case "$2" in '') usage ;; esac
346 case "$2" in '') usage ;; esac
351 reference_path="${1#--reference=}"
354 case "$2" in '') usage ;; esac
359 case "$2" in '') usage ;; esac
380 if test -n "$reference_path"
382 is_absolute_path "$reference_path" ||
383 reference_path="$wt_prefix$reference_path"
385 reference="--reference=$reference_path"
391 if test -z "$sm_path"; then
392 sm_path=$(printf '%s\n' "$repo" |
393 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
396 if test -z "$repo" || test -z "$sm_path"; then
400 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
402 # assure repo is absolute or relative to parent
405 test -z "$wt_prefix" ||
406 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
408 # dereference source url relative to parent's url
409 realrepo=$(resolve_relative_url "$repo") || exit
416 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
421 # multiple //; leading ./; /./; /../; trailing /
422 sm_path=$(printf '%s/\n' "$sm_path" |
432 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
433 die "$(eval_gettext "'\$sm_path' already exists in the index")"
435 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
437 eval_gettextln "The following path is ignored by one of your .gitignore files:
439 Use -f if you really want to add it." >&2
443 if test -n "$custom_name"
445 sm_name="$custom_name"
450 # perhaps the path exists and is already a git repo, else clone it
451 if test -e "$sm_path"
453 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
455 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
457 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
461 if test -d ".git/modules/$sm_name"
465 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
466 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
467 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
468 echo >&2 " $realrepo"
469 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
470 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
472 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
475 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
479 # ash fails to wordsplit ${branch:+-b "$branch"...}
481 '') git checkout -f -q ;;
482 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
484 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
486 git config submodule."$sm_name".url "$realrepo"
488 git add $force "$sm_path" ||
489 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
491 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
492 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
495 git config -f .gitmodules submodule."$sm_name".branch "$branch"
497 git add --force .gitmodules ||
498 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
502 # Execute an arbitrary command sequence in each checked out
505 # $@ = command to execute
509 # parse $args after "submodule ... foreach".
531 # dup stdin so that it can be restored when running the external
532 # command in the subshell (and a recursive call to this function)
536 while read mode sha1 stage sm_path
538 die_if_unmatched "$mode"
539 if test -e "$sm_path"/.git
541 displaypath=$(relative_path "$sm_path")
542 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
543 name=$(module_name "$sm_path")
545 prefix="$prefix$sm_path/"
548 sm_path=$(relative_path "$sm_path") &&
549 # we make $path available to scripts ...
557 if test -n "$recursive"
559 cmd_foreach "--recursive" "$@"
562 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
568 # Register submodules in .git/config
570 # $@ = requested paths (default to all)
574 # parse $args after "submodule ... init".
596 while read mode sha1 stage sm_path
598 die_if_unmatched "$mode"
599 name=$(module_name "$sm_path") || exit
601 displaypath=$(relative_path "$sm_path")
603 # Copy url setting when it is not set yet
604 if test -z "$(git config "submodule.$name.url")"
606 url=$(git config -f .gitmodules submodule."$name".url)
608 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
610 # Possibly a url relative to parent
613 url=$(resolve_relative_url "$url") || exit
616 git config submodule."$name".url "$url" ||
617 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
619 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
622 # Copy "update" setting when it is not set yet
623 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
625 test -z "$(git config submodule."$name".update)"
628 checkout | rebase | merge | none)
629 ;; # known modes of updating
631 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
635 git config submodule."$name".update "$upd" ||
636 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
642 # Unregister submodules from .git/config and remove their work tree
644 # $@ = requested paths (use '.' to deinit all submodules)
648 # parse $args after "submodule ... deinit".
674 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
678 while read mode sha1 stage sm_path
680 die_if_unmatched "$mode"
681 name=$(module_name "$sm_path") || exit
683 displaypath=$(relative_path "$sm_path")
685 # Remove the submodule work tree (unless the user already did it)
686 if test -d "$sm_path"
688 # Protect submodules containing a .git directory
689 if test -d "$sm_path/.git"
691 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
692 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
697 git rm -qn "$sm_path" ||
698 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
701 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
702 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
705 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
707 # Remove the .git/config entries (unless the user already did it)
708 if test -n "$(git config --get-regexp submodule."$name\.")"
710 # Remove the whole section so we have a clean state when
711 # the user later decides to init this submodule again
712 url=$(git config submodule."$name".url)
713 git config --remove-section submodule."$name" 2>/dev/null &&
714 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
720 # Update each submodule path to correct revision, using clone and checkout as needed
722 # $@ = requested paths (default to all)
726 # parse $args after "submodule ... update".
749 case "$2" in '') usage ;; esac
750 reference="--reference=$2"
766 case "$2" in '') usage ;; esac
789 cmd_init "--" "$@" || return
795 while read mode sha1 stage sm_path
797 die_if_unmatched "$mode"
800 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
803 name=$(module_name "$sm_path") || exit
804 url=$(git config submodule."$name".url)
805 branch=$(get_submodule_config "$name" branch master)
806 if ! test -z "$update"
808 update_module=$update
810 update_module=$(git config submodule."$name".update)
811 if test -z "$update_module"
813 update_module="checkout"
817 displaypath=$(relative_path "$prefix$sm_path")
819 if test "$update_module" = "none"
821 echo "Skipping submodule '$displaypath'"
827 # Only mention uninitialized submodules when its
828 # path have been specified
830 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
831 Maybe you want to use 'update --init'?")"
835 if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
837 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
838 cloned_modules="$cloned_modules;$name"
841 subsha1=$(clear_local_git_env; cd "$sm_path" &&
842 git rev-parse --verify HEAD) ||
843 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
848 if test -z "$nofetch"
850 # Fetch remote before determining tracking $sha1
851 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
852 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
854 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
855 sha1=$(clear_local_git_env; cd "$sm_path" &&
856 git rev-parse --verify "${remote_name}/${branch}") ||
857 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
860 if test "$subsha1" != "$sha1" || test -n "$force"
863 # If we don't already have a -f flag and the submodule has never been checked out
864 if test -z "$subsha1" && test -z "$force"
869 if test -z "$nofetch"
871 # Run fetch only if $sha1 isn't present or it
872 # is not reachable from a ref.
873 (clear_local_git_env; cd "$sm_path" &&
874 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
875 test -z "$rev") || git-fetch)) ||
876 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
879 # Is this something we just cloned?
880 case ";$cloned_modules;" in
882 # then there is no local change to integrate
883 update_module=checkout ;;
887 case "$update_module" in
889 command="git checkout $subforce -q"
890 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
891 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
895 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
896 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
897 must_die_on_failure=yes
901 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
902 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
903 must_die_on_failure=yes
906 command="${update_module#!}"
907 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
908 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
909 must_die_on_failure=yes
912 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
915 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
918 elif test -n "$must_die_on_failure"
920 die_with_status 2 "$die_msg"
922 err="${err};$die_msg"
927 if test -n "$recursive"
930 prefix="$prefix$sm_path/"
938 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
941 err="${err};$die_msg"
944 die_with_status $res "$die_msg"
971 git describe "$2" 2>/dev/null ||
972 git describe --tags "$2" 2>/dev/null ||
973 git describe --contains "$2" 2>/dev/null ||
974 git describe --all --always "$2"
977 test -z "$revname" || revname=" ($revname)"
980 # Show commit summary for submodules in index or working tree
982 # If '--cached' is given, show summary between index and given commit,
983 # or between working tree and given commit
985 # $@ = [commit (default 'HEAD'),] requested paths (default all)
992 # parse $args after "submodule ... summary".
1007 isnumber "$summary_limit" || usage
1011 summary_limit="${1#--summary-limit=}"
1012 isnumber "$summary_limit" || usage
1028 test $summary_limit = 0 && return
1030 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1033 test $# = 0 || shift
1034 elif test -z "$1" || test "$1" = "HEAD"
1036 # before the first commit: compare with an empty tree
1037 head=$(git hash-object -w -t tree --stdin </dev/null)
1038 test -z "$1" || shift
1045 test -n "$cached" &&
1046 die "$(gettext "The --cached option cannot be used with the --files option")"
1052 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1053 # Get modified modules cared by user
1054 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1055 sane_egrep '^:([0-7]* )?160000' |
1056 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1058 # Always show modules deleted or type-changed (blob<->module)
1059 if test "$status" = D || test "$status" = T
1061 printf '%s\n' "$sm_path"
1064 # Respect the ignore setting for --for-status.
1065 if test -n "$for_status"
1067 name=$(module_name "$sm_path")
1068 ignore_config=$(get_submodule_config "$name" ignore none)
1069 test $status != A && test $ignore_config = all && continue
1071 # Also show added or modified modules which are checked out
1072 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1073 printf '%s\n' "$sm_path"
1077 test -z "$modules" && return
1079 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1080 sane_egrep '^:([0-7]* )?160000' |
1082 while read mod_src mod_dst sha1_src sha1_dst status name
1084 if test -z "$cached" &&
1085 test $sha1_dst = 0000000000000000000000000000000000000000
1089 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1091 100644 | 100755 | 120000)
1092 sha1_dst=$(git hash-object $name)
1098 eval_gettextln "unexpected mode \$mod_dst" >&2
1105 test $mod_src = 160000 &&
1106 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1109 test $mod_dst = 160000 &&
1110 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1113 display_name=$(relative_path "$name")
1116 case "$missing_src,$missing_dst" in
1118 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1121 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1124 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1129 if test $mod_src = 160000 && test $mod_dst = 160000
1131 range="$sha1_src...$sha1_dst"
1132 elif test $mod_src = 160000
1138 GIT_DIR="$name/.git" \
1139 git rev-list --first-parent $range -- | wc -l
1141 total_commits=" ($(($total_commits + 0)))"
1145 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1146 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1149 blob="$(gettext "blob")"
1150 submodule="$(gettext "submodule")"
1151 if test $mod_dst = 160000
1153 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1155 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1158 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1160 if test -n "$errmsg"
1162 # Don't give error msg for modification whose dst is not submodule
1163 # i.e. deleted or changed to blob
1164 test $mod_dst = 160000 && echo "$errmsg"
1166 if test $mod_src = 160000 && test $mod_dst = 160000
1169 test $summary_limit -gt 0 && limit="-$summary_limit"
1170 GIT_DIR="$name/.git" \
1171 git log $limit --pretty='format: %m %s' \
1172 --first-parent $sha1_src...$sha1_dst
1173 elif test $mod_dst = 160000
1175 GIT_DIR="$name/.git" \
1176 git log --pretty='format: > %s' -1 $sha1_dst
1178 GIT_DIR="$name/.git" \
1179 git log --pretty='format: < %s' -1 $sha1_src
1187 # List all submodules, prefixed with:
1188 # - submodule not initialized
1189 # + different revision checked out
1191 # If --cached was specified the revision in the index will be printed
1192 # instead of the currently checked out revision.
1194 # $@ = requested paths (default to all)
1198 # parse $args after "submodule ... status".
1226 while read mode sha1 stage sm_path
1228 die_if_unmatched "$mode"
1229 name=$(module_name "$sm_path") || exit
1230 url=$(git config submodule."$name".url)
1231 displaypath=$(relative_path "$prefix$sm_path")
1232 if test "$stage" = U
1234 say "U$sha1 $displaypath"
1237 if test -z "$url" ||
1239 ! test -d "$sm_path"/.git &&
1240 ! test -f "$sm_path"/.git
1243 say "-$sha1 $displaypath"
1246 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1248 set_name_rev "$sm_path" "$sha1"
1249 say " $sha1 $displaypath$revname"
1251 if test -z "$cached"
1253 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1255 set_name_rev "$sm_path" "$sha1"
1256 say "+$sha1 $displaypath$revname"
1259 if test -n "$recursive"
1262 prefix="$displaypath/"
1267 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1272 # Sync remote urls for submodules
1273 # This makes the value for remote.$remote.url match the value
1274 # specified in .gitmodules.
1303 while read mode sha1 stage sm_path
1305 die_if_unmatched "$mode"
1306 name=$(module_name "$sm_path")
1307 url=$(git config -f .gitmodules --get submodule."$name".url)
1309 # Possibly a url relative to parent
1312 # rewrite foo/bar as ../.. to find path from
1313 # submodule work tree to superproject work tree
1314 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1315 # guarantee a trailing /
1316 up_path=${up_path%/}/ &&
1317 # path from submodule work tree to submodule origin repo
1318 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1319 # path from superproject work tree to submodule origin repo
1320 super_config_url=$(resolve_relative_url "$url") || exit
1323 sub_origin_url="$url"
1324 super_config_url="$url"
1328 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1330 displaypath=$(relative_path "$prefix$sm_path")
1331 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1332 git config submodule."$name".url "$super_config_url"
1334 if test -e "$sm_path"/.git
1339 remote=$(get_default_remote)
1340 git config remote."$remote".url "$sub_origin_url"
1342 if test -n "$recursive"
1344 prefix="$prefix$sm_path/"
1353 # This loop parses the command line arguments to find the
1354 # subcommand name to dispatch. Parsing of the subcommand specific
1355 # options are primarily done by the subcommand implementations.
1356 # Subcommand specific options such as --branch and --cached are
1357 # parsed here as well, for backward compatibility.
1359 while test $# != 0 && test -z "$command"
1362 add | foreach | init | deinit | update | status | summary | sync)
1392 # No command word defaults to "status"
1393 if test -z "$command"
1403 # "-b branch" is accepted only by "add"
1404 if test -n "$branch" && test "$command" != add
1409 # "--cached" is accepted only by "status" and "summary"
1410 if test -n "$cached" && test "$command" != status && test "$command" != summary